from PIL import Image
from os import listdir

palettedata = [
    0, 0, 0,
    255, 255, 255,
    67, 138, 28,
	0, 10, 255,
    191, 0, 0,
	255, 243, 56,
	232, 126, 0,
    ]


pic_directory="C:/Users/msbee/OneDrive/Documents/Yavuz Lab/Assorted Nonsense/Screen Images/"
save_directory="C:/Users/msbee/OneDrive/Documents/Yavuz Lab/Assorted Nonsense/Screen Images/Final/"

filenames=list()
for filename in listdir(pic_directory):
    if filename[-3:] in ['jpg', 'epg', 'png']:
        filenames.append(filename)



# def (img):
#     if img.size[0]<img.size[1]:
#         resized_image=img.resize((262, 448))
#     else: 
#         resized_image=img.resize((448, 262))
#         #resized_image=resized_image.rotate(90, expand=1)  #make sure all images are long in horizontal direction)
#     return(resized_image)



def check_size(img):
    aspect_ratio = img.size[0]/img.size[1]
    def rescale(img):
        if aspect_ratio >= .585:
            x_size = 600   #for full screen image
            # x_size=262      #for picture space sized image
            y_size = int(x_size / aspect_ratio)
            img=img.resize((x_size, y_size))  
            return(img)
        else:
            y_size = 448
            x_size = int(y_size * aspect_ratio)
            img=img.resize((x_size, y_size))  
            return(img)

    print(filename)
    print(img.size[0]/img.size[1])
    img=rescale(img)
   
    
    return(img)
    

    
    
def convert_image(img, filename, save_file=True, show_img=False):
    p_img = Image.new('P', (16, 16))
    p_img.putpalette(palettedata * 32)
    resized_img = img
    colored_img = resized_img.quantize(palette=p_img)
    if show_img==True:
       colored_img.show()
    
    pixels=(list(colored_img.getdata()))
    if save_file:
        name=filename.split('.', 1)[0]+'.txt'
        with open(save_directory+name, 'w') as f:
            f.write(str(img.size[1]))
            f.write('\n')
            for i,pixel in enumerate(pixels):
                f.write(str(pixel))
                if i% img.size[0]==img.size[0]-1:
                    f.write('\n')
            
        f.close()

    colored_img.close()



def convert_all():
    for file in filenames:

        img=Image.open(pic_directory+file)
        try: 
            img=check_size(img)
            convert_image(img,file)
            print(img.size)
        except Exception as e:
            print(e)
            print("Couldn't conver't %s" %file)
        img.close()
            
#test=Image.open('A_Pretty_Little_Dude.jpg')
#convert_image(test)

convert_all()



